% This program computes the eight 4pi multitapers.
% format: [v,lambda]=mt4pi(x), where the output v contains the 8 eigen-tapers,
% lambda contains the corresponding 8 eigenvalues, and x is the time series (used
% here only to get its length).
%
function [v,lambda,c]=mt4pi(x)
n=length(x);
p=4;p2=p*2;
w=p/n;
disp('building the Toeplitz matrix...')
c0=zeros(n,1);
c0(1)=2*w;
for i=2:n
   i1=i-1;
   c0(i)=sin(2*pi*w*i1)./(pi*i1);
end
c=toeplitz(c0);
disp('solving the eigens...')
[v,d]=eig(c);
d=diag(d);
[d,k]=sort(d);
d=flipud(d);
k=flipud(k);
lambda=d(1:8);
v=v(:,k);
v=v(:,1:p2);
for i=1:2:p2
   if mean(v(:,i))<0
   v(:,i)=-v(:,i);
   end
end
figure(1),plot(v)

